//+------------------------------------------------------------------+
//|                                           Trinves_Stochastic.mq4 |
//|                                                             2008 |
//+------------------------------------------------------------------+

#property link      "http://www.trinves.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Yellow //  Stochastic           |55 
#property indicator_width1 1      //  Stochastic       |
#property indicator_color2 Red    //  Stochastic           |
#property indicator_width2 1      //  Stochastic       |

#property indicator_color3 Yellow //                                            |
#property indicator_width3 1      //  Stochastic           |55 
#property indicator_style3 2      //  Stochastic       |
#property indicator_color4 Red    //                                            |
#property indicator_width4 1      //  Stochastic           |
#property indicator_style4 2      //  Stochastic       |

#property indicator_level1 80
#property indicator_level2 20


 int TimeFrame;
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE);
   

    
  }
//----
   return(0);
 

int start()
  {
  if (Period()==10080) {TimeFrame=43200;}
  if (Period()==1440) {TimeFrame=10080;}
  if (Period()==240) {TimeFrame=1440;}
  if (Period()==60) {TimeFrame=240;}
  if (Period()==30) {TimeFrame=240;}
  if (Period()==15) {TimeFrame=60;}
  if (Period()==5) {TimeFrame=30;}
  if (Period()==1) {TimeFrame=5;}
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 
    
   ExtMapBuffer1[i]=iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MODE_SMA,0,0,y);
   ExtMapBuffer2[i]=iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MODE_SMA,0,1,y);
   ExtMapBuffer3[i]=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,0,i);
   ExtMapBuffer4[i]=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,1,i);
   }  
     

   
  
  
   return(0);
  }
//+------------------------------------------------------------------+